local CBP_oldBuffAffectUnit = BuffAffectUnit

function BuffAffectUnit(unit, buffName, instigator, afterRemove)
    
    local buffDef = Buffs[buffName]
    local buffAffects = buffDef.Affects

# this is done in the regular function which is called below
#    if buffDef.OnBuffAffect and not afterRemove then
#        buffDef:OnBuffAffect(unit, instigator)
#    end
    
    for atype, vals in buffAffects do
         if atype == 'ShieldMaxHealth' then               # shield max health

            if not unit.MyShield then
                return
            end
            local MyShield = unit.MyShield
            local unitshieldbphealth = unit:GetBlueprint().Defense.Shield.ShieldMaxHealth or 1
            local ratio = ( MyShield:GetHealth() / MyShield:GetMaxHealth() )
            local newMax = math.ceil( BuffCalculate( unit, buffName, atype, unitshieldbphealth ) )
            MyShield:SetMaxHealth(newMax)
            MyShield:SetHealth(MyShield, (newMax * ratio) )
#            LOG('Buffing unit shield: new max health = '..repr(newMax))
            LOG('Ignore the \'trying to apply unknown affects\' warning coming up next')
            
         elseif atype == 'ShieldRegen' then               # shield regeneration
            
            if not unit.MyShield then
                return
            end
            local MyShield = unit.MyShield
            local bpshieldregn = unit:GetBlueprint().Defense.Shield.ShieldRegenRate or 0
            newRegn = math.ceil( BuffCalculate(unit, buffName, atype, bpshieldregn) )
            MyShield:SetShieldRegenRate( newRegn )
#            LOG('Buffing unit shield regeneration rate: new rate = '..repr(newRegn))
            LOG('Ignore the \'trying to apply unknown affects\' warning coming up next')

        end
    end

    CBP_oldBuffAffectUnit(unit, buffName, instigator, afterRemove)
end
